|
【导读】:树是数据结构中的重中之重,尤其以各类二叉树为学习的难点。在面试环节中,二叉树也是必考的模块。本文主要讲二叉树操作的相关知识,梳理面试常考的内容。请大家跟随小编一起来复习吧。 & x& j' s. E4 W* M 本篇针对面试中常见的二叉树操作作个总结:
对于当前结点,先输出该结点,然后输出它的左孩子,最后输出它的右孩子。以上图为例,递归的过程如下:
而非递归版本只是利用 stack 模拟上述过程而已,递归的过程也就是出入栈的过程。 /* 前序遍历递归版 */void PreOrderRec(Node * node) {- F+ p; q6 e6 i, A if (node == nullptr). c4 z* P9 K% ]8 u9 d# C return; cout << node->data << " "; // 先输出当前结点 % u% z* E( E/ d1 k$ c PreOrderRec(node->left); // 然后输出左孩子& ?5 M- [: |! U4 k PreOrderRec(node->right); // 最后输出右孩子 } /* 前序遍历非递归版 */ void PreOrderNonRec(Node * node) {% l! i5 h$ m8 r if (node == nullptr) return;0 y& ]/ T& `" w0 `/ o1 a$ g ; w- ^) m) Z' r8 f1 Y7 ]6 B3 } stack<Node*> S;# T' K, W$ Y, V8 n) A cout << node->data << " "; S.push(node);& ^0 ]5 K3 R: Z$ i' O node = node->left;* j8 g1 f2 ~1 x. Y) Y# Z _ # z* ?: F" r# Y7 x. A2 p while (!S.empty() || node) {, b# U D: ]9 O+ }/ _5 o% H while (node) { cout << node->data << " "; // 先输出当前结点 # [# G" _; p2 Y+ n- K8 P S.push(node);) ~# h. g% q) W node = node->left; // 然后输出左孩子 } // while 结束意味着左孩子已经全部输出7 E+ M" |, s1 Q' f% G1 u node = S.top()->right; // 最后输出右孩子 S.pop(); }1 R; `' i9 d& z } 1.2 中序遍历 对于当前结点,先输出它的左孩子,然后输出该结点,最后输出它的右孩子。以(1.1)图为例:
void InOrderRec(Node * node)( Z9 G+ ]+ v1 o8 F0 N( E { if (node == nullptr)$ Q# D9 T T6 z/ r return; 7 A W. k( k Z" d2 N F0 e1 s, ~0 ` InOrderRec(node->left); // 先输出左孩子 cout << node->data << " "; // 然后输出当前结点 InOrderRec(node->right); // 最后输出右孩子; G; B) L; a" }6 g2 F% o }) k( p8 R4 G9 L3 j* Q! k* i; ~ /* 前序遍历非递归版 */ void InOrderNonRec(Node * node)7 V' F7 H! _8 S) M {7 @* S5 S( W: u6 H; a+ v6 p1 U if (node == nullptr)( }, `: [0 x1 \ return;$ z' }' z5 g4 |7 ]8 ~ $ B7 B. y {% o& w! z& u stack<Node*> S;" u2 F3 V7 K" W3 N3 }5 O' z8 \+ `2 t S.push(node);& T' ~! r) I% M9 ^8 z4 N- s node = node->left;$ D X, t; q! a ; X$ l! S3 w; P1 b while (!S.empty() || node) {; T) k. m j/ ] w, A while (node) {2 Y# |$ y9 l9 o3 n S.push(node); t3 k( u( w( S" E$ Y( p2 U. o6 L- ?$ d node = node->left;$ b/ v+ q9 o: J, {! h } // while 结束意味着左孩子为空" m/ z% R$ P; z* I + p8 g) `) j) o4 X& Y2 s cout << S.top()->data << " "; // 左孩子已经全部输出,接着输出当前结点 node = S.top()->right; // 左孩子全部输出,当前结点也输出后,最后输出右孩子 S.pop();5 n9 ^7 r/ v$ J- b* |" }$ L }, _# Z! Z/ Z6 t7 R( b/ T2 ]' e } 1.3 后序遍历 对于当前结点,先输出它的左孩子,然后输出它的右孩子,最后输出该结点。依旧以(1.1)图为例:
非递归版本中,对于一个结点,如果我们要输出它,只有它既没有左孩子也没有右孩子或者它有孩子但是它的孩子已经被输出(由此设置 pre 变量)。若非上述两种情况,则将该结点的右孩子和左孩子依次入栈,这样就保证了每次取栈顶元素的时候,先依次遍历左子树和右子树。 /* 后序遍历递归版 */' c, n" p& I5 T' q1 ~ K5 Ovoid PostOrderRec(Node * node)% Z' H& B6 J' g8 s B+ o( C/ b {( _+ A% g3 H- k! Y if (node == nullptr)+ A' C( q- P$ v* m1 V! i5 D return; PostOrderRec(node->left); // 先输出左孩子6 N' Q# G) L& w4 s/ b$ j PostOrderRec(node->right); // 然后输出右孩子2 B) b3 `" ~7 f, H7 `: M2 U cout << node->data << " "; // 最后输出当前结点 } /* 后序遍历非递归版 */4 T) L7 G, C8 o$ G* E" p void PostOrderNonRec(Node * node) {3 ]" j* S$ S r- m, [ if (node == nullptr); u" h# e3 Y6 Y) N7 }/ O5 y return;7 M1 A: c! Z( L3 U . r6 U7 @& f9 t9 j& J" A Node * pre = nullptr;# I* `: A# m) m5 W$ [& t: M stack<Node*> S;5 ]7 u& y- y) K* y0 I- P1 {3 D8 [( c$ ^ S.push(node); " c# |- @2 o) q. I: d7 ?) H while (!S.empty()) {% t+ g" h. x# |) ]) L node = S.top(); 6 N/ d: i- a! h) W, g, ^3 d if ((!node->left && !node->right) || // 第一个输出的必是无左右孩子的叶子结点,只要第一个结点输出,. n9 Q( W# s, p4 g (pre && (pre == node->left || pre == node->right))) // 以后的 pre 就不会是空。此处的判断语句加入一个 pre,只是用来 { // 确保可以正确输出第一个结点。; y D( V9 y2 j- }7 K7 x8 z7 L cout << node->data << " "; // 左右孩子都全部输出,再输出当前结点3 r7 K: J6 D8 a2 C pre = node;8 \ [( M( ?6 x8 Z- x& o S.pop(); } else9 q1 v' U5 M" P" C! G- e { if (node->right), \3 B, ^+ y# k. n+ A( o S.push(node->right); // 先进右孩子,再进左孩子,取出来的才是左孩子 if (node->left)/ L+ P9 g$ D9 L1 T- \8 I S.push(node->left);3 @3 V# ~" v2 O% P9 J }0 b _# L) ?( f- ^) @4 T7 N) L" V }$ |6 q% j, t* B. i; ` }- B" h: O ]! W+ q7 A3 T 2 层次遍历void LevelOrder(Node * node) { Node * p = node; queue<Node*> Q; // 队列 Q.push(p); while (!Q.empty())" F9 X; }1 D8 ^1 Y% P. D { p = Q.front();# J% ?5 i/ M8 u: s cout << p->data << " ";" c: u" N( T$ [& L4 }& s, p Q.pop(); ; Y* W' B" n: @* D4 y" q* |6 | if (p->left)& \) B4 D- i; ~* S f" _7 l Q.push(p->left); // 注意顺序,先进左孩子# p% f$ t. S( g1 G2 E) `, B if (p->right)3 W+ T" O4 l: }: P Q.push(p->right); } } 3 求树的结点数int CountNodes(Node * node)8 T2 { W0 P }5 o2 H { if (node == nullptr) return 0;* C) W% B" N+ J return CountNodes(node->left) + CountNodes(node->right) + 1;& I+ P" M$ x7 I; r } 4 求树的叶子数int CountLeaves(Node * node) { if (node == nullptr) return 0;! T' ?. J& a: R, ? F if (!node->left && !node->right) return 1; % r/ j5 v5 H' n) S: ?' G5 e return CountLeaves(node->left) + CountLeaves(node->right);1 e& U/ v* M. q4 t7 T- D1 H } 5 求树的深度int GetDepth(Node * node) {7 @8 J4 F/ T7 J if (node == nullptr) return 0; ) x- ]& P t. [4 h, G t5 [ int left_depth = GetDepth(node->left) + 1; int right_depth = GetDepth(node->right) + 1; return left_depth > right_depth ? left_depth : right_depth; }; I. J! a' f) {4 f# N 6 求二叉树第k层的结点个数int GetKLevel(Node * node, int k) {, {# ?# r7 ]# A if (node == nullptr). O3 w+ ~( L" @) [- u return 0;! j9 f5 a/ {6 r% A e8 N ) p/ [- {, c0 D; P+ m1 @ if (k == 1)) }/ H% n6 t, Q/ d0 l return 1; return GetKLevel(node->left, k - 1) + GetKLevel(node->right, k - 1); }0 ]. ^3 J- e% c* Y- j 7 判断两棵二叉树是否结构相同 不考虑数据内容。结构相同意味着对应的左子树和对应的右子树都结构相同。 bool StructureCmp(Node * node1, Node * node2): h: o' u8 j9 H5 ?( g$ i{5 E+ B' s0 [( i! d7 X: Z3 K1 V if (node1 == nullptr && node2 == nullptr) return true;3 e# w a7 m- o; S0 E1 c else if (node1 == nullptr || node2 == nullptr) return false;) V# c' p9 H- X$ |+ P return StructureCmp(node1->left, node2->left) && Str1uctureCmp(node1->right, node2->right); }# ~3 {7 Y1 V& }" n4 W+ H M 8 求二叉树的镜像 对于每个结点,我们交换它的左右孩子即可。 void Mirror(Node * node){. X5 b; [ p0 q( O if (node == nullptr) return;$ D" N! v- W9 N9 ^0 E1 F1 z' r Node * temp = node->left; node->left = node->right;# Q: Y- [' H. r7 V5 j# L4 y node->right = temp; Mirror(node->left);, Z% |2 k* e$ v' c) | Mirror(node->right); }) F. G/ b# @* E5 s 9 求两个结点的最低公共祖先结点 最低公共祖先,即 LCA(Lowest Common Ancestor),见下图:
结点 3 和结点 4 的最近公共祖先是结点 2,即 LCA(3,4)=2。在此,需要注意到当两个结点在同一棵子树上的情况,如结点 3 和结点 2 的最近公共祖先为 2,即 LCA(3,2)=2。同理 LCA(5,6)=4,LCA(6,10)=1。 Node * FindLCA(Node * node, Node * target1, Node * target2), j$ z7 {4 R! S8 ~+ J{5 S2 X( k" l m- T" H8 K0 ? if (node == nullptr) return nullptr; if (node == target1 || node == target2) return node; Node * left = FindLCA(node->left, target1, target2); Node * right = FindLCA(node->right, target1, target2);! b3 z% P$ o) N4 J4 |. ~& n0 ~ if (left && right) // 分别在左右子树 return node;% l5 Y6 Y, G5 j* L/ [: n 7 A' Y7 @8 F: h5 F6 |5 v# w return left ? left : right; // 都在左子树或右子树; K2 G6 a; Z8 w) ^! U }. K$ e* a: H! Y- Q/ K2 H- b 10 求任意两结点距离
首先找到两个结点的 LCA,然后分别计算 LCA 与它们的距离,最后相加即可。 int FindLevel(Node * node, Node * target){ if (node == nullptr) return -1; if (node == target) return 0; int level = FindLevel(node->left, target); // 先在左子树找5 ~8 I# a2 k! W" i# W if (level == -1)/ ?8 w: {3 j8 p0 u% t$ A level = FindLevel(node->right, target); // 如果左子树没找到,在右子树找! @2 Z' E ~2 j if (level != -1) // 找到了,回溯 return level + 1; 5 u7 W* e, ^8 a* ^0 H9 e: f0 K: J return -1; // 如果左右子树都没找到 } int DistanceNodes(Node * node, Node * target1, Node * target2)! i" _( g# b, B% D1 p2 I {" H3 \$ w& E( `" R" p' e- A Node * lca = FindLCA(node, target1, target2); // 找到最低公共祖先结点8 K Q4 H( a) E; d! O$ e5 b3 a9 t int level1 = FindLevel(lca, target1); : X' p5 n# w( j' V int level2 = FindLevel(lca, target2);1 T& P. d ]$ O+ v% T# F% ~ 7 X7 f: t! l; {! N! t+ t4 g return level1 + level2;, B p* w5 f/ a }+ ~: |7 m, _/ T. c8 w5 K 11 找出二叉树中某个结点的所有祖先结点
如果给定结点 5,则其所有祖先结点为 4,2,1。 bool FindAllAncestors(Node * node, Node * target). C1 D' q; y/ `2 |$ u) M* H. T! I{, I! H* a! d) A# E if (node == nullptr) return false;# A3 X. Z& g' m/ o' n# f6 Z if (node == target): V$ Z1 X) F% t% v0 [ O; J) d+ V return true; if (FindAllAncestors(node->left, target) || FindAllAncestors(node->right, target)) // 找到了 {* Z" y* V, N/ v! C6 `5 ` H cout << node->data << " ";) d( ~* y0 W7 S: Z& F6 w return true; // 回溯 }5 A: b0 M i% |: r3 S# V 0 g) w6 W0 J: e G! }* \ return false; // 如果左右子树都没找到 }8 ]% Z, J' p1 T- _+ B 12 不使用递归和栈遍历二叉树 1968 年,高德纳(Donald Knuth)提出一个问题:是否存在一个算法,它不使用栈也不破坏二叉树结构,但是可以完成对二叉树的遍历?随后 1979 年,James H. Morris 提出了二叉树线索化,解决了这个问题。(根据这个概念我们又提出了一个新的数据结构,即线索二叉树,因线索二叉树不是本文要介绍的内容,所以有兴趣的朋友请移步线索二叉树) 前序,中序,后序遍历,不管是递归版本还是非递归版本,都用到了一个数据结构--栈,为何要用栈?那是因为其它的方式没法记录当前结点的 parent,而如果在每个结点的结构里面加个 parent 分量显然是不现实的,而线索化正好解决了这个问题,其含义就是利用结点的右孩子空指针,指向该结点在中序序列中的后继。下面具体来看看如何使用线索化来完成对二叉树的遍历。
先看前序遍历,步骤如下:
/* 前序遍历 */ void PreOrderMorris(Node * root) { Node * cur = root; Node * pre = nullptr; while (cur)# q. e8 S# G8 s/ W, n/ j- G. S" ~" l8 J {) _- o% [7 u7 l x9 G7 s% V if (cur->left == nullptr) // 步骤 1& m' V! h* U# b S {" r: |0 R) [' N$ S& D0 o cout << cur->data << " ";- Q# w7 R2 N0 k6 x% | cur = cur->right;2 w- }1 Z2 Q, j }# e# C l+ c; ~ else {, v, p3 B) B5 h2 R, E. M; q, F3 h9 r pre = cur->left;7 x. n) I" `+ ]# v0 B0 y while (pre->right && pre->right != cur) // 步骤 2,找到 cur 的前驱结点& ` {* u O; f/ X' [- c) [% T: a. Y pre = pre->right;( P+ `' Z$ F0 Y8 M6 m * g! L& c2 J \) M: Y" W2 }$ T if (pre->right == nullptr) // 步骤 2.1,cur 未被访问,将 cur 结点作为其前驱结点的右孩子 {" [" X* a) D- e+ C1 @* t$ ]: \ cout << cur->data << " ";0 Y+ j3 @8 ]7 n pre->right = cur; cur = cur->left;. s/ i4 d- Y6 G" l7 z! j }6 |8 I2 H& w/ U0 w. f) J3 z else // 步骤 2.2,cur 已被访问,恢复树的原有结构,更改 right 指针 {& {3 h |6 T( t5 |5 G3 V pre->right = nullptr;+ R4 F ^* ?7 \8 K* | cur = cur->right;& u2 v3 X& F7 ^1 y/ B$ L } } } }( U6 }6 n$ }9 p2 u+ r 再来看中序遍历,和前序遍历相比只改动一句代码,步骤如下:
void InOrderMorris(Node * root) { Node * cur = root;) o; z6 a9 I' ?, l Node * pre = nullptr; while (cur)' W, b1 x/ Q8 O { if (cur->left == nullptr) //(1); j! b8 L/ B0 q* g- Q {. U: p2 }3 Z- y cout << cur->data << " "; cur = cur->right; }+ i# a& \) i6 Y) \ else, u0 z: ^+ H$ I { pre = cur->left;! i1 _" l" l! {, c. _ while (pre->right && pre->right != cur) //(2),找到 cur 的前驱结点 pre = pre->right;2 |; G, u" ]1 W4 O3 | if (pre->right == nullptr) //(2.1),cur 未被访问,将 cur 结点作为其前驱结点的右孩子( l9 e3 P2 T3 K! O4 y+ T6 k2 } {. V- u8 R4 Q9 Y# U: r% u pre->right = cur; cur = cur->left;8 f3 Z! q5 h5 Q }' U( P) k! t9 E; D0 d( N else //(2.2),cur 已被访问,恢复树的原有结构,更改 right 指针 * E+ V4 b( I, M' J" M { cout << cur->data << " "; pre->right = nullptr;1 m7 _1 b5 [/ k4 t. a cur = cur->right; }; S; c! t# X# T' J: i* G, Y m } }' u+ X t: {. ?6 ?# \5 x } 最后看下后序遍历,后序遍历有点复杂,需要建立一个虚假根结点 dummy,令其左孩子是 root。并且还需要一个子过程,就是倒序输出某两个结点之间路径上的各个结点。
步骤如下:
{ int data; Node * left; Node * right; Node(int data_, Node * left_, Node * right_) {9 p# E8 H/ W# ]9 ^' ]0 T9 ~! J4 ` data = data_; left = left_; right = right_; } }; void ReversePrint(Node * from, Node * to) { if (from == to)& o) F: A/ e3 A4 s& v5 x {' k# u* O4 ~+ C. ] cout << from->data << " ";, [# W1 f. f/ p return; } ReversePrint(from->right, to); cout << from->data << " ";" N9 K$ N% A9 X& _ }" q% Y5 R6 @5 G6 q2 P8 Y void PostOrderMorris(Node * root)) ~$ g- b) `7 F { Node * dummy = new Node(-1, root, nullptr); // 一个虚假根结点 Node * cur = dummy; Node * pre = nullptr;- o# g$ F) o+ N" | while (cur) {0 \& H" J5 u' u# K if (cur->left == nullptr) // 步骤 1$ L" E" x7 ]3 X& | cur = cur->right;' K/ U0 @( `/ o+ m; r8 {0 D& z else, K, T& w6 z( W9 v6 b4 w {# V$ q5 E2 O* z2 b" k pre = cur->left; while (pre->right && pre->right != cur) // 步骤 2,找到 cur 的前驱结点9 h; U$ P" s* t) K. f5 V8 p pre = pre->right;# q: j; p& K& Y if (pre->right == nullptr) // 步骤 2.1,cur 未被访问,将 cur 结点作为其前驱结点的右孩子; b- q3 ? L$ U& t; U) R3 M: J( e {/ |7 {( r/ x8 m) A9 q pre->right = cur;0 l8 ?7 X l. r2 ]( ?2 a cur = cur->left;2 X, W1 `9 Y( h2 f }+ a$ W3 B1 C$ `# d0 A: p8 f* o! y else // 步骤 2.2,cur 已被访问,恢复树的原有结构,更改 right 指针5 ~% Z6 }8 M9 ]# n- L$ g9 F* V { pre->right = nullptr;6 @4 O1 K$ A+ b. r: H/ ^ ReversePrint(cur->left, pre); cur = cur->right; }" M$ u2 B6 j4 s/ T5 O N } }7 D3 ^- O/ X/ _& E( G# d; l( H }5 x' [2 E+ _" n dummy 用的非常巧妙,建议读者配合上面的图模拟下算法流程。 13 二叉树前序中序推后序方式 序列 前序 [1 2 4 7 3 5 8 9 6] 中序 [4 7 2 1 8 5 9 3 6] 后序 [7 4 2 8 9 5 6 3 1] 以上面图表为例,步骤如下:
int pre_order_arry[n]; int in_order_arry[n];* M; \8 G- `. `. p' h( k void PrintPostOrder(int pos1, int pos2, int n) {+ }, j* _- x6 t9 h if (n == 1) { cout << pre_order_arry[pos1]; o. B* [- H% M! d1 F return; } if (n == 0) return; 5 B3 Y3 K1 y% M2 P) i% W+ G0 ]% B int i = 0;2 @' A2 x- } O for (; pre_order_arry[pos1] != in_order_arry[pos2 + i]; i++) ;$ e; `( z- \3 o& s- E! l PrintPostOrder(pos1 + 1, pos2, i); PrintPostOrder(pos1 + i + 1, pos2 + i + 1, n - i - 1); cout << pre_order_arry[pos1];% b- W8 U0 X2 U3 x( \% t {: S" P) G# { }7 ~; f2 W1 X, p) c 当然我们也可以根据前序和中序构造出二叉树,进而求出后序。 /* 该函数返回二叉树的根结点 */Node * Create(int pos1, int pos2, int n), p8 y3 e4 K( U1 j6 q2 K: p5 C {) C2 O4 c: Q" n/ v$ ?( I4 l Node * p = nullptr;3 e( d8 T/ N. V4 _! l6 |1 L for (int i = 0; i < n; i++)3 ~8 Z2 W8 M! |: C! y% \2 G* e { if (pre_order_arry[pos1] == in_order_arry[pos2 + i])! @& M$ C# L4 o( C {) D ?- g# E' _9 c3 C: {- e4 O p = new Node(pre_order_arry[pos1]); p->left = Create(pos1 + 1, pos2, i); p->right = Create(pos1 + i + 1, pos2 + i + 1, n - i - 1);* a! i5 N6 }" B1 H2 b return p; }* H8 d& t9 Z4 N7 O! C }2 F. h5 Z0 ^! L9 g3 S& f0 \ $ ]$ ^2 J$ }$ l$ A; _' q. Q return p;" b! j+ I, O1 q9 X9 {+ y+ H } 14 判断二叉树是不是完全二叉树 若设二叉树的深度为 h,除第 h 层外,其它各层 (1~h-1) 的结点数都达到最大个数,第 h 层所有的结点都连续集中在最左边,这就是完全二叉树(Complete Binary Tree)。如下图:
首先若一个结点只有右孩子,肯定不是完全二叉树;其次若只有左孩子或没有孩子,那么接下来的所有结点肯定都没有孩子,否则就不是完全二叉树,因此设置 flag 标记变量。 bool IsCBT(Node * node){" Q' H- d6 @5 } bool flag = false;1 J7 {1 ?: u/ Z1 C) A4 ` queue<Node*> Q;0 E8 H: T7 \% ], z. }# \9 o" q Q.push(node);( y J0 w9 V/ f5 Q/ l - s% J+ J, U1 Y, K, U while (!Q.empty()) {/ Z& T. a4 i, |8 ] Node * p = Q.front();! [- P/ Q( I4 x# o Q.pop(); if (flag) V1 \& B0 @9 K, ~8 U5 Z { if (p->left || p->right) return false;+ b- w6 ]6 [: |# h }! I s1 G& C# H' S0 D: H else { if (p->left && p->right)+ `, O1 v2 e- o( a8 [# D+ @ { Q.push(p->left); Q.push(p->right); }. e1 q9 X+ ~, j1 s( A6 s7 S/ o3 ] else if (p->right) // 只有右结点# }& z3 d# V' @% k+ y* R return false; else if (p->left) // 只有左结点 { Q.push(p->left);" l3 \* g7 X1 C" g2 |. s& p flag = true; }5 Z8 P% G: L& }! f else // 没有结点 flag = true; }- v2 N1 u, ^( x$ |' k$ J } return true; }4 q: Y8 q: |. W1 p+ g' E% D 15 判断是否是二叉查找树的后序遍历结果 在后续遍历得到的序列中,最后一个元素为树的根结点。从头开始扫描这个序列,比根结点小的元素都应该位于序列的左半部分;从第一个大于跟结点开始到跟结点前面的一个元素为止,所有元素都应该大于跟结点,因为这部分元素对应的是树的右子树。根据这样的划分,把序列划分为左右两部分,我们递归地确认序列的左、右两部分是不是都是二元查找树。 int array[n]; // 长度为 n 的序列,注意 begin 和 end 遵循的是左闭右闭原则bool IsSequenceOfBST(int begin, int end) { if (end - begin <= 0) return true; 5 t8 |8 `/ t2 k3 X int root_data = array[end]; // 数组尾元素为根结点' U9 {% A" K+ p9 C) H Z int i = begin;6 \/ L' z9 L( h0 l$ ` for (; array < root_data; i++) // 取得左子树+ R- U7 G/ H" J+ c9 M, b ; int j = i;4 t) a. _' { E& g7 {5 u W. B G for (; j < end; j++) t: [" a8 b* N, U& {" R* ] if (array[j] < root_data) // 此时右子树应该都大于根结点;若存在小于,直接 return false return false;; D2 D- J$ Q/ o : k2 t, i7 f$ Z$ V return IsSequenceOfBST(begin, i - 1) && IsSequenceOfBST(i, end - 1); // 左右子树是否都满足 }6 H5 u, V) J2 Y8 \( L 16 给定一个二叉查找树中的结点(存在一个指向父亲结点的指针),找出在中序遍历下它的后继和前驱 一棵二叉查找树的中序遍历序列,正好是升序序列。假如根结点的父结点为 nullptr,则:
Node * Increment(Node * node) {- c3 b+ ~' T/ |) r; e if (node->right) // 步骤 12 u# J9 B1 `( U% C# S { node = node->right; while (node->left)) j) w) d5 V: `' N8 J node = node->left;8 N& p1 A2 Y* o% L return node; } else // 步骤 2 {( c+ U- B2 k$ k& {2 G B if (node->parent == nullptr) // 步骤 2.1 return nullptr;3 j* a x- \6 |$ w6 Q Node * p = node->parent; // 步骤 2.2 if (p->left == node) // 步骤 2.2.1& z5 g- T0 w# K$ t6 @* |/ a O. o return p;! d p, q7 P; J else // 步骤 2.2.2 { while (p->right == node): [% D: |8 e0 i4 z5 f2 n: [ {) i* _, A! H$ k9 s _" t node = p;$ ?. u- Y+ ?( D& B p = p->parent;6 Q( c6 a5 e1 s. L% k if (p == nullptr)0 g$ y7 D( T6 i0 R) n! s6 q% C return nullptr; }, Y( z' M- b/ X$ ^+ E return p; } }7 b7 ~6 }3 P! ]! U) X0 U0 d8 u } 仔细观察上述代码,总觉得有点啰嗦。比如,过多的 return,步骤 2 的层次太多。综合考虑所有情况,改进代码如下: Node * Increment(Node * node)6 W7 {9 V1 D0 _% U{ if (node->right) {/ u0 J/ ]9 C4 P- V node = node->right;% _, _5 o- f" \ while (node->left) node = node->left; } else/ ^) a9 T2 P) v% V { Node * p = node->parent; while (p && p->right == node): H$ `6 f2 z$ p. O$ y Z {. m+ A- n+ o3 ]* t2 A node = p; p = p->parent; } node = p;( p1 b7 P9 @7 ^: f* z7 b$ z } E8 s! r7 w. ~5 a . a3 f' k( V" q6 ?) T, M return node; } 上述的代码是基于结点有 parent 指针的,若题意要求没有 parent 呢?网上也有人给出了答案,个人觉得没有什么价值,有兴趣的朋友可以到这里查看。 而求前驱结点的话,只需把上述代码的 left 与 right 互调即可,很简单。 17 二分查找树转化为排序的循环双链表二分查找树的中序遍历即为升序排列,问题就在于如何在遍历的时候更改指针的指向。一种简单的方法时,遍历二分查找树,将遍历的结果放在一个数组中,之后再把该数组转化为双链表。如果题目要求只能使用 O(1)O(1) 内存,则只能在遍历的同时构建双链表,即进行指针的替换。 我们需要用递归的方法来解决,假定每个递归调用都会返回构建好的双链表,可把问题分解为左右两个子树。由于左右子树都已经是有序的,当前结点作为中间的一个结点,把左右子树得到的链表连接起来即可。 /* 合并两个 a, b 两个循环双向链表 */Node * Append(Node * a, Node * b). c& g1 J5 t+ v) v { if (a == nullptr) return b; if (b == nullptr) return a;) v: c0 h% v- ^5 s // 分别得到两个链表的最后一个元素 Node * a_last = a->left;: s4 A+ H0 Z" N1 a% y Node * b_last = b->left; $ R" P' x0 G. h // 将两个链表头尾相连 , \2 p3 i7 a+ P1 n3 g5 a6 ~1 I8 I7 T a_last->right = b;' X1 D% |' D) x- v1 b b->left = a_last;$ g" o* n, b, f a->left = b_last;, V- P$ T. d6 q1 ^5 s9 p b_last->right = a; 4 u* O! g9 q, j/ O% n3 u Y return a;9 \& s% I# y s$ C- B2 }' k" | }2 i% a0 f9 U8 M8 }. f2 F* c- X /* 递归的解决二叉树转换为双链表 */ Node * TreeToList(Node * node)4 q) b2 | i* h( z4 S {$ o' f* E/ R* d4 P1 | if (node == nullptr) return nullptr; 7 @+ `2 j& b$ U // 递归解决子树. g6 I" y5 f. i$ j. d Node * left_list = TreeToList(node->left);2 [* X3 m4 T/ H# A Node * right_list = TreeToList(node->right); // 把根结点转换为一个结点的双链表,方便后面的链表合并 node->left = node; node->right = node;7 S. {1 B3 ?; D% V9 K8 D // 合并之后即为升序排列, ` @# d, P! ^" \; E4 A# O' g left_list = Append(left_list, node); left_list = Append(left_list, right_list);- S$ y# ~8 W8 I# \& A" ^ 0 [6 W& E, R" E+ E return left_list; }2 |5 \4 `: t+ N! H$ b: t0 E 18 有序链表转化为平衡的二分查找树(Binary Search Tree) 我们可以采用自顶向下的方法。先找到中间结点作为根结点,然后递归左右两部分。所以我们需要先找到中间结点,对于单链表来说,必须要遍历一边,可以使用快慢指针加快查找速度。 struct TreeNode{, k$ [/ `' v$ i' Z4 E) r' c$ T int data; TreeNode * left; TreeNode * right; TreeNode(int data_) { data = data_; left = right = nullptr; } }; % D$ ^$ f# U8 c2 E. J, x struct ListNode. c k' i9 N8 ?2 R5 @" g { int data; ListNode * next;, N( | S3 P& C- U: z3 G* c9 P ListNode(int data_) { data = data_; next = nullptr; }9 x+ ]6 x1 C9 V% _8 x' A2 F3 p5 R: t4 F- r };. ]' a8 `5 G9 ] L5 O5 e- E3 I9 ] TreeNode * SortedListToBST(ListNode * list_node) { if (!list_node) return nullptr;3 R6 W0 `4 U) \& I. D7 l6 g3 N0 L if (!list_node->next) return (new TreeNode(list_node->data));" @; {& P) q# U $ d; T, R6 v) O6 O0 j0 q7 Z // 用快慢指针找到中间结点 ListNode * pre_slow = nullptr; // 记录慢指针的前一个结点0 C; e6 Y9 p+ h ListNode * slow = list_node; // 慢指针 ListNode * fast = list_node; // 快指针 while (fast && fast->next)9 R! M! X$ h9 F/ i5 S {# ~0 Z/ t8 g& V5 x9 u pre_slow = slow;$ V2 H `& O M$ s; n2 n2 y slow = slow->next; fast = fast->next->next; }' `/ _; H4 z# f' e TreeNode * mid = new TreeNode(slow->data); ' R5 L I+ g+ v# | x; B- P9 O$ i // 分别递归左右两部分0 F5 k/ w' J6 U4 K if (pre_slow)5 A- t$ w4 e4 p# y) s& X {- y2 P S& K& ? pre_slow->next = nullptr;, a, \ I- H2 R) v( Z+ s$ p mid->left = SortedListToBST(list_node); }# z8 @5 J, O) t b mid->right = SortedListToBST(slow->next);; [( E' u: h! K6 P return mid;- r3 y5 y- ^7 u2 C' H: ` }, a) O/ O) w" l& m H: r1 u 由 f(n)=2f(\frac n2)+\frac n2f(n)=2f(2n)+2n 得,所以上述算法的时间复杂度为 O(nlogn)O(nlogn)。 不妨换个思路,采用自底向上的方法: 7 A1 f' N7 ~' u$ D+ bTreeNode * SortedListToBSTRec(ListNode *& list, int start, int end) {% F) M3 y8 b8 ~1 @ if (start > end) return nullptr; # O" c2 t* [) i$ l) `+ _0 ]: e& [6 q int mid = start + (end - start) / 2; TreeNode * left_child = SortedListToBSTRec(list, start, mid - 1); // 注意此处传入的是引用 TreeNode * parent = new TreeNode(list->data); parent->left = left_child;1 |: t; `9 a/ Q& c$ l r list = list->next;7 Q6 n9 ~. P; x ~ parent->right = SortedListToBSTRec(list, mid + 1, end);& [! a2 N: L7 g; R' p return parent; } TreeNode * SortedListToBST(ListNode * node) {( X, R5 Q' [( J5 A0 [ int n = 0;+ Z' c6 Z( \* x8 U7 y, t ListNode * p = node; while (p)/ g2 j5 U/ P: k) \, G/ D' H5 | { n++;' \# ~ b! E7 F5 z* k% g p = p->next; } # d3 d4 S% c9 e1 M return SortedListToBSTRec(node, 0, n - 1);. N* H, f2 o) u8 u6 G* h }5 P5 N9 D9 f4 y6 r; v0 [- P. P/ E5 O 如此,时间复杂度降为 O(n)O(n)。 19 判断是否是二叉查找树我们假定二叉树没有重复元素,即对于每个结点,其左右孩子都是严格的小于和大于。 下面给出两个方法: 方法 1: bool IsBST(Node * node, int min, int max)% ~" p) p7 R2 V3 c L( C$ r' Q* @0 Z{ if (node == nullptr). V! @+ k! C- W! Z6 R return true; if (node->data <= min || node->data >= max)! V8 h( N c g' z1 n, U% L+ D return false;6 p% l7 f+ l! `% O0 D& \ & |/ N# G" F; D& y6 `4 ?) x return IsBST(node->left, min, node->data) && IsBST(node->right, node->data, max);) x4 U4 _6 n$ |7 P' a, g) g }: K) O' n9 p" j, _# r+ r3 O IsBST(node, INT_MIN, INT_MAX); 方法 2: 利用二叉查找树中序遍历时元素递增来判断。 bool IsBST(Node * node)& L# @$ P% Q* {! r& q% V. k{1 Y8 Z$ ]8 d% H" u. I7 g static int pre = INT_MIN;5 y2 P" U9 `4 m 4 O' S" _- Y' f0 U5 O* c if (node == nullptr) return true; 6 D4 G% f5 F" z- o if (!IsBST(node->left)); W# a- m# l+ J- M; ] return false;0 G/ c* `9 y* L: t$ N ! A& l! H$ g( R if (node->data < pre)$ L" y# ?) M# O( b/ m return false; pre = node->data;2 E/ A5 ~: Q; @; L( p , V+ G8 k- S) s- Z- ~( O return IsBST(node->right); } |
微信公众号
手机版